package miner;

import jmadem.*;
import jason.asSyntax.*;
import jason.asSemantics.*;
import java.lang.Math.*;
import java.util.*;

/** 
 *
 * @author Francisco Grimaldo
 */
public class goldDistance implements utilityFunctionInt 
{
	/**
	  * Returns the name of the utility function
	  *
	  * @return	"goldDistance"
	  */
    public String getId()
	{
		return "goldDistance";
	}
	
	/**
	  * Returns the highest normalized utility value for any allocation. 
	  *
	  * @param	auctioneer	agent asking for preference
	  * @param	alloc	allocation being evaluated
	  * 
	  * @throws	UtilityFunctionException when any error occurs
	  * @return	MAX - distance of agent to gold 
	  */
    public float computeUtility(String auctioneer, Allocation a, MADeMAgArch agArch) throws utilityFunctionException
	{
		Term [] termArray;
		Unifier un = new Unifier();
		Literal l, pos;
		
		Literal alloc = (Literal)a.getTerm();
		termArray = alloc.getTermsArray();
		String ag = termArray[2].toString();
		//System.out.println(ag + agArch.getAgName());
 		if(!ag.equals( agArch.getAgName())) 
			return 0;
 		if(auctioneer.equals( agArch.getAgName()))
			return 0;
		l = Literal.parseLiteral("free");
		pos = agArch.getTS().getAg().findBel(l, un);
		if(pos == null) {
			//System.out.println(agArch.getAgName()+ " no esta free");
			return 0;
		}
		l = Literal.parseLiteral("carrying_gold");
		pos = agArch.getTS().getAg().findBel(l, un);
		if(pos != null) {
			//System.out.println(agArch.getAgName()+ "  esta carrying_gold");
			return 0;
		}
		String sx = termArray[0].toString();
 		String sy = termArray[1].toString();
		l = Literal.parseLiteral("allocated(gold("+sx+","+sy+",_))");
		pos = agArch.getTS().getAg().findBel(l, un);
		if(pos != null)
			return 0;
		Integer x = Integer.parseInt(termArray[0].toString());
 		Integer y = Integer.parseInt(termArray[1].toString());
		l = Literal.parseLiteral("pos(_,_)");
		pos = agArch.getTS().getAg().findBel(l, un);
		if (pos == null)
			return 0;
		termArray = pos.getTermsArray();
		Integer ax = Integer.parseInt(termArray[0].toString());
 		Integer ay = Integer.parseInt(termArray[1].toString());
		
		return 1000 - (Math.abs(x-ax)+ Math.abs(y-ay) );
		//return 1;
	}
}

