package testAgent;

import jmadem.*;

/** 
 * Test utility function always returning the lowest normalized utility value (0),
 * regardless of the allocation being considered.
 *
 * @author Francisco Grimaldo
 */
public class minimumUtilityFunction implements utilityFunctionInt 
{
	/**
	  * Returns the name of the utility function
	  *
	  * @return	"minimumUtilityFunction"
	  */
    public String getId()
	{
		return "minimumUtilityFunction";
	}
	
	/**
	  * Returns the lowest normalized utility value for any allocation. 
	  *
	  * @param	auctioneer	agent asking for preference
	  * @param	alloc	allocation being evaluated
	  * 
	  * @throws	utilityFunctionException when any error occurs
	  * @return	always 0, which will be the preference assigned to any allocation 
	  */
    public float computeUtility(String auctioneer, Allocation a, MADeMAgArch agArch) throws utilityFunctionException
	{
		return 0;
	}
}

